/*
These are preparations for a true64 port, the port is not functional yet.
This file is not required for any other flavor.
*/


#include "newlisp.h"
#include "protos.h"

#pragma pointer_size long

#include "ffi-tru64-4.0/ffi.h"

#define FORMAT_MAX_ARGS 32

/* Port by Peter van Eerten - peter@gtk-server.org */

typedef union {
    int   ivalue;
    double dvalue;
    char   *pvalue;
} FFITYPE;


int tru64_vasprintf(FFITYPE holder[], ffi_type * argtypes[], void * argptr[], int amount)
{
UINT size = MAX_STRING;
int pSize;

/* Contains pointer to FFI_CIF structure */
ffi_cif cif;

while(TRUE)
	{
	/* This is the resultbuffer to which sprintf will print */
	holder[0].pvalue = (void *)allocMemory(size);
	argtypes[0] = &ffi_type_pointer;
	argptr[0] = &holder[0].pvalue;
	/* Initialize the cif */
	if (ffi_prep_cif(&cif, FFI_DEFAULT_ABI, amount, &ffi_type_uint, argtypes) == FFI_OK)
	{
		/* We can safely ignore the 'size' parameter since we are putting a list of arrays here */
		ffi_call(&cif, (void*)sprintf, &pSize, argptr);
	}

	/* Tru64Unix returns a negative number upon unsuccesfull completion */
	if(pSize < 0)
		{
		freeMemory(holder[0].pvalue);
		size += size/2;
		continue;
	}
	break;
}

return(pSize);
}

/* 
 * This is a special routine for Tru64 Unix to accomodate
 * the 'format' function of newLisp. It uses the FFI library
 * (Foreign Function Interface) to send the format and
 * arguments to.
 *
 * Ported by Peter van Eerten.
 */
 


CELL * p_format(CELL * params)
{
/* These variables are needed for FFI */
#pragma pointer_size long
ffi_type *argtypes[FORMAT_MAX_ARGS];
void *args[FORMAT_MAX_ARGS];
FFITYPE holder[FORMAT_MAX_ARGS];
#pragma pointer_size short

char * format;
char * fmt;
CELL * cell;
char * ptr;
int len = 1;
int fType;
double floatNum;
UINT intNum;

params = getString(params, &format);
fmt = format;

/* Here we capture the format sent by newLisp */
holder[len].pvalue = fmt;
argtypes[len] = &ffi_type_pointer;
args[len] = &holder[len].pvalue;
len += 1;

while(params->type != CELL_NIL)
    {
    fmt = getFormatType(fmt, &fType);

    if(fmt == NULL)
        {
        return(errorProcExt2(ERR_FORMAT_STRING, stuffString(format)));
        }

    if(fType == 0)
        {
        return(errorProcExt(ERR_FORMAT_NUM_ARGS, params));
        }

    if(fType == CELL_INT32)
        {
        getInteger(params, &intNum);
		holder[len].ivalue = intNum;
      	argtypes[len] = &ffi_type_uint;
      	args[len] = &holder[len].ivalue;
		len += 1;
	params = params->next;
	continue;
	}

    if(fType == CELL_FLOAT)
    {
    	getFloat(params, &floatNum);
		holder[len].dvalue = floatNum;
      	argtypes[len] = &ffi_type_double;
      	args[len] = &holder[len].dvalue;
		len += 1;
    params = params->next;
    continue;
    }

    cell = evaluateExpression(params);

    if(fType != cell->type)
        {
        return(errorProcExt(ERR_FORMAT_DATA_TYPE, params));
        }

	holder[len].ivalue = cell->contents;
   	argtypes[len] = &ffi_type_uint;
   	args[len] = &holder[len].ivalue;
	len += 1;

    params = params->next;
    }

getFormatType(fmt, &fType);
if(fType != 0)
    {
    errorProcExt2(ERR_FORMAT_NUM_ARGS, stuffString(format));
    }

tru64_vasprintf(holder, argtypes, args, len);

cell = getCell(CELL_STRING);
cell->aux = strlen(holder[0].pvalue) + 1;
cell->contents = (UINT)holder[0].pvalue;

return(cell);
}

