/**
 * Name: newlisp
 * Description: newLISP.
 * Version: 1.8
 */

state newlisp extends HighlightEntry
{
  /* Comments. */
  /;|#/ {
    comment_face (true);
    language_print ($0);
    call (eat_one_line);
    comment_face (false);
  }

  /* String constants. */
  /\"/ {
    string_face (true);
    language_print ($0);
    call (c_string);
    string_face (false);
  }

/* why does this not work? */
 /\[text\].*\[\/text\]/ {
    string_face (true);
    language_print ($0);
    string_face (false);
    }

 /\{.*\}/ {
    string_face (true);
    language_print ($0);
    string_face (false);
    }


  /* Definitions. */
  /(\([ \t]*)(define)([ \t]+\(?)([!\$%&\*\/:<=>\?~_^a-zA-Z][!\$%&\*\/:<=>\?~_^a-zA-Z0-9.+\-]*)/ {
    /* Starting garbage. */
    language_print ($1);

    /* Keyword `define'. */
    keyword_face (true);
    language_print ($2);
    keyword_face (false);

    /* Middle garbage. */
    language_print ($3);

    /* Function name. */
    function_name_face (true);
    language_print ($4);
    function_name_face (false);
  }

/*
  map'ed functors are not highlighted correctly, same probably for apply'd functors
*/

  /((\B)(\*|\/|\+|\-|>|<|=|&)(\B))|(([^a-zA-z0-9\"\#\-_])\
(!|!=|\$|\$0|\$1|\$2|\$3|\$4|\$5|\$6|\$7|\$8|\$9|<<|<=\
|NaN\?|\^|abs|acos|add|address|amb|and|append|append-file|apply|args|array|array-list|array\?\
|asin|assoc|atan|atan2|atom\?|base|base64-dec|base64-enc|begin|beta|betai|binomial|case|catch|ceil\
|change-dir|char|chop|clean|close|command-line|cond|cons|constant|context|context\?|copy-file|cos\
|count|cpymem|crc32|crit-chi2|crit-z|current-line|date|date-value|debug|dec|def-new|define\
|define-macro|delete|delete-file|device|difference|directory|directory\?|div|do-until|do-while\
|dolist|dotimes|dotree|dump|dup|empty\?|encrypt|ends-with|env|erf|error-event|error-number|error-text\
|eval|eval-string|exec|exit|exp|expand|explode|factor|fft|file-info|file\?|filter|find|first|flat\
|float|float|floor|flt|fn|for|fork|format|fv|gammai|gammaln|get-char|get-float|get-int|get-integer\
|get-string|get-url|global|if|ifft|import|inc|index|int|integer|integer\?|intersect|invert|irr\
|join|lambda|lambda\?|last|legal\?|length|let|letex|letn|list|list\?|load|log|lookup|lower-case|macro\?\
|main-args|make-dir|map|match|max|member|min|mod|mul|multiply|name|net-accept|net-close|net-connect\
|net-error|net-eval|net-listen|net-local|net-lookup|net-peek|net-peer|net-ping|net-receive\
|net-receive-from|net-receive-udp|net-select|net-send|net-send-to|net-send-udp|net-service\
|net-sessions|new|nil|nil\?|normal|not|now|nper|npv|nth|nth-set|number\?|open|or|pack|parse|peek\
|pipe|pmt|pop|post-url|pow|pretty-print|primitive\?|print|println|prob-chi2|prob-z|process|push\
|put-url|pv|quote|quote\?|rand|random|randomize|read-buffer|read-char|read-file|read-key|read-line\
|real-path|ref|regex|remove-dir|rename-file|replace|replace-assoc|reset|rest|reverse|rotate|save\
|search|seed|seek|select|semaphore|sequence|serie|set|set!|set-locale|set-nth|setq|sgn|share\
|signal|silent|sin|sleep|slice|sort|source|sqrt|starts-with|string|string\?|sub|swap|sym|symbol\
|symbol\?|symbols|sys-error|sys-info|tan|throw|throw-error|time|time-of-day|timer|title-case|trace\
|trace-highlight|transpose|trim|true|true\?|unify|unique|unless|unpack|until|upper-case|wait-pid|while\
|write-buffer|write-char|write-file|write-line|xml-error|xml-parse|xml-type-tags|zero\?|\||~)\
([^a-zA-Z0-9\"\-_]))/{
    language_print ($6);
    keyword_face (true);
    language_print ($3);
    language_print ($7);
    keyword_face (false);
    language_print ($8);
  }
}

/*
Local variables:
mode: c
End:
*/

